Automatic Copyright Year update after running gdb/copyright.py
[deliverable/binutils-gdb.git] / gdb / contrib / cc-with-tweaks.sh
CommitLineData
6432ec65 1#!/usr/bin/env bash
853254db
TT
2# Wrapper around gcc to tweak the output in various ways when running
3# the testsuite.
ea65fe05 4
88b9d363 5# Copyright (C) 2010-2022 Free Software Foundation, Inc.
ea65fe05
DE
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; either version 3 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see <http://www.gnu.org/licenses/>.
18
19# This program requires gdb and objcopy in addition to gcc.
0b5574da
DE
20# The default values are gdb from the build tree and objcopy from $PATH.
21# They may be overridden by setting environment variables GDB and OBJCOPY
63b46266
YPK
22# respectively. Note that GDB should contain the gdb binary as well as the
23# -data-directory flag, e.g., "foo/gdb -data-directory foo/data-directory".
ea65fe05
DE
24# We assume the current directory is either $obj/gdb or $obj/gdb/testsuite.
25#
26# Example usage:
27#
28# bash$ cd $objdir/gdb/testsuite
29# bash$ runtest \
6432ec65
JK
30# CC_FOR_TARGET="/bin/bash $srcdir/gdb/contrib/cc-with-tweaks.sh ARGS gcc" \
31# CXX_FOR_TARGET="/bin/bash $srcdir/gdb/contrib/cc-with-tweaks.sh ARGS g++"
ea65fe05 32#
fb8cf7c5
DE
33# For documentation on Fission and dwp files:
34# http://gcc.gnu.org/wiki/DebugFission
35# http://gcc.gnu.org/wiki/DebugFissionDWP
ea65fe05 36# For documentation on index files: info -f gdb.info -n "Index Files"
853254db
TT
37# For information about 'dwz', see the announcement:
38# http://gcc.gnu.org/ml/gcc/2012-04/msg00686.html
39# (More documentation is to come.)
ea65fe05 40
853254db 41# ARGS determine what is done. They can be:
ea9f10bb 42# -Z invoke objcopy --compress-debug-sections
853254db
TT
43# -z compress using dwz
44# -m compress using dwz -m
9d6d4be8
TV
45# -i make an index (.gdb_index)
46# -n make a dwarf5 index (.debug_names)
7fb2b84a 47# -p create .dwp files (Fission), you need to also use gcc option -gsplit-dwarf
778ae9cc 48# -l creates separate debuginfo files linked to using .gnu_debuglink
853254db
TT
49# If nothing is given, no changes are made
50
51myname=cc-with-tweaks.sh
6432ec65 52mydir=`dirname "$0"`
ea65fe05
DE
53
54if [ -z "$GDB" ]
55then
56 if [ -f ./gdb ]
57 then
63b46266 58 GDB="./gdb -data-directory data-directory"
ea65fe05
DE
59 elif [ -f ../gdb ]
60 then
63b46266 61 GDB="../gdb -data-directory ../data-directory"
b8e9bd6c
DE
62 elif [ -f ../../gdb ]
63 then
63b46266 64 GDB="../../gdb -data-directory ../../data-directory"
ea65fe05
DE
65 else
66 echo "$myname: unable to find usable gdb" >&2
67 exit 1
68 fi
69fi
70
71OBJCOPY=${OBJCOPY:-objcopy}
80626a55 72READELF=${READELF:-readelf}
ea65fe05 73
853254db 74DWZ=${DWZ:-dwz}
80626a55 75DWP=${DWP:-dwp}
853254db 76
ea65fe05
DE
77have_link=unknown
78next_is_output_file=no
00e14314 79output_file=a.out
ea65fe05 80
853254db 81want_index=false
9d6d4be8 82index_options=""
853254db
TT
83want_dwz=false
84want_multi=false
80626a55 85want_dwp=false
ea9f10bb 86want_objcopy_compress=false
778ae9cc 87want_gnu_debuglink=false
853254db
TT
88
89while [ $# -gt 0 ]; do
90 case "$1" in
ea9f10bb 91 -Z) want_objcopy_compress=true ;;
853254db
TT
92 -z) want_dwz=true ;;
93 -i) want_index=true ;;
9d6d4be8 94 -n) want_index=true; index_options=-dwarf-5;;
853254db 95 -m) want_multi=true ;;
80626a55 96 -p) want_dwp=true ;;
778ae9cc 97 -l) want_gnu_debuglink=true ;;
853254db
TT
98 *) break ;;
99 esac
100 shift
101done
102
6432ec65
JK
103if [ "$want_index" = true ]
104then
105 if [ -z "$GDB_ADD_INDEX" ]
106 then
107 if [ -f $mydir/gdb-add-index.sh ]
108 then
109 GDB_ADD_INDEX="$mydir/gdb-add-index.sh"
110 else
111 echo "$myname: unable to find usable contrib/gdb-add-index.sh" >&2
112 exit 1
113 fi
114 fi
115fi
116
ea65fe05
DE
117for arg in "$@"
118do
119 if [ "$next_is_output_file" = "yes" ]
120 then
121 output_file="$arg"
122 next_is_output_file=no
123 continue
124 fi
125
126 # Poor man's gcc argument parser.
127 # We don't need to handle all arguments, we just need to know if we're
128 # doing a link and what the output file is.
129 # It's not perfect, but it seems to work well enough for the task at hand.
130 case "$arg" in
131 "-c") have_link=no ;;
132 "-E") have_link=no ;;
133 "-S") have_link=no ;;
134 "-o") next_is_output_file=yes ;;
135 esac
136done
137
138if [ "$next_is_output_file" = "yes" ]
139then
140 echo "$myname: Unable to find output file" >&2
141 exit 1
142fi
143
144if [ "$have_link" = "no" ]
145then
146 "$@"
147 exit $?
148fi
149
ea65fe05
DE
150output_dir="${output_file%/*}"
151[ "$output_dir" = "$output_file" ] && output_dir="."
152
153"$@"
154rc=$?
155[ $rc != 0 ] && exit $rc
156if [ ! -f "$output_file" ]
157then
158 echo "$myname: Internal error: $output_file missing." >&2
159 exit 1
160fi
161
0df0352a
TV
162get_tmpdir ()
163{
778ae9cc
TV
164 subdir="$1"
165 if [ "$subdir" = "" ]; then
166 subdir=.tmp
167 fi
168
169 tmpdir=$(dirname "$output_file")/"$subdir"
0df0352a
TV
170 mkdir -p "$tmpdir"
171}
172
ea9f10bb
TT
173if [ "$want_objcopy_compress" = true ]; then
174 $OBJCOPY --compress-debug-sections "$output_file"
175 rc=$?
176 [ $rc != 0 ] && exit $rc
177fi
178
853254db 179if [ "$want_index" = true ]; then
f80cb3b4
TV
180 get_tmpdir
181 mv "$output_file" "$tmpdir"
182 tmpfile="$tmpdir/$(basename $output_file)"
6432ec65
JK
183 # Filter out these messages which would stop dejagnu testcase run:
184 # echo "$myname: No index was created for $file" 1>&2
185 # echo "$myname: [Was there no debuginfo? Was there already an index?]" 1>&2
f80cb3b4 186 GDB=$GDB $GDB_ADD_INDEX $index_options "$tmpfile" 2>&1 \
9d6d4be8 187 | grep -v "^${GDB_ADD_INDEX##*/}: " >&2
6432ec65 188 rc=${PIPESTATUS[0]}
f80cb3b4 189 mv "$tmpfile" "$output_file"
853254db
TT
190 [ $rc != 0 ] && exit $rc
191fi
192
193if [ "$want_dwz" = true ]; then
a9eac7f9
SM
194 # Validate dwz's result by checking if the executable was modified.
195 cp "$output_file" "${output_file}.copy"
196 $DWZ "$output_file" > /dev/null
197 cmp "$output_file" "$output_file.copy" > /dev/null
198 cmp_rc=$?
199 rm -f "${output_file}.copy"
200
201 case $cmp_rc in
202 0)
203 echo "$myname: dwz did not modify ${output_file}."
204 exit 1
205 ;;
206 1)
207 # File was modified, great.
208 ;;
209 *)
210 # Other cmp error, it presumably has already printed something on
211 # stderr.
212 exit 1
213 ;;
214 esac
853254db 215elif [ "$want_multi" = true ]; then
0df0352a
TV
216 get_tmpdir
217 dwz_file=$tmpdir/$(basename "$output_file").dwz
a9eac7f9
SM
218 # Remove the dwz output file if it exists, so we don't mistake it for a
219 # new file in case dwz fails.
0df0352a 220 rm -f "$dwz_file"
a9eac7f9 221
853254db 222 cp $output_file ${output_file}.alt
0df0352a 223 $DWZ -m "$dwz_file" "$output_file" ${output_file}.alt > /dev/null
6892f601 224 rm -f ${output_file}.alt
a9eac7f9
SM
225
226 # Validate dwz's work by checking if the expected output file exists.
0df0352a
TV
227 if [ ! -f "$dwz_file" ]; then
228 echo "$myname: dwz file $dwz_file missing."
a9eac7f9
SM
229 exit 1
230 fi
ea65fe05
DE
231fi
232
80626a55
DE
233if [ "$want_dwp" = true ]; then
234 dwo_files=$($READELF -wi "${output_file}" | grep _dwo_name | \
235 sed -e 's/^.*: //' | sort | uniq)
20d7f211
DE
236 rc=0
237 if [ -n "$dwo_files" ]; then
238 $DWP -o "${output_file}.dwp" ${dwo_files} > /dev/null
239 rc=$?
240 [ $rc != 0 ] && exit $rc
241 rm -f ${dwo_files}
242 fi
80626a55
DE
243fi
244
778ae9cc
TV
245if [ "$want_gnu_debuglink" = true ]; then
246 # Based on gdb_gnu_strip_debug.
247
248 # Gdb looks for the .gnu_debuglink file in the .debug subdirectory
249 # of the directory of the executable.
250 get_tmpdir .debug
251
252 stripped_file="$tmpdir"/$(basename "$output_file").stripped
253 debug_file="$tmpdir"/$(basename "$output_file").debug
254
255 # Create stripped and debug versions of output_file.
256 strip --strip-debug "${output_file}" \
257 -o "${stripped_file}"
258 rc=$?
259 [ $rc != 0 ] && exit $rc
260 strip --only-keep-debug "${output_file}" \
261 -o "${debug_file}"
262 rc=$?
263 [ $rc != 0 ] && exit $rc
264
265 # The .gnu_debuglink is supposed to contain no leading directories.
266 link=$(basename "${debug_file}")
267
268 (
269 # Temporarily cd to tmpdir to allow objcopy to find $link
270 cd "$tmpdir" || exit 1
271
272 # Overwrite output_file with stripped version containing
273 # .gnu_debuglink to debug_file.
274 objcopy --add-gnu-debuglink="$link" "${stripped_file}" \
275 "${output_file}"
276 rc=$?
277 [ $rc != 0 ] && exit $rc
278 )
279fi
280
ea65fe05 281exit $rc
This page took 0.775527 seconds and 4 git commands to generate.